package com.devplatform.admin.modules.sys.oauth2;

import com.devplatform.common.base.exception.RRException;
import java.security.MessageDigest;
import java.util.UUID;

/**
 * 生成token
 *
 * @author chenshun
 * @email sunlightcs@gmail.com
 * @date 2017-05-20 14:41
 */
public class TokenGenerator {

  private static final char[] HEX_CODE = "0123456789abcdef".toCharArray();

  public static String generateValue() {
    return generateValue(UUID.randomUUID().toString());
  }

  public static String toHexString(byte[] data) {
    if (data == null) {
      return null;
    }
    StringBuilder r = new StringBuilder(data.length * 2);
    for (byte b : data) {
      r.append(HEX_CODE[(b >> 4) & 0xF]);
      r.append(HEX_CODE[(b & 0xF)]);
    }
    return r.toString();
  }

  public static String generateValue(String param) {
    try {
      MessageDigest algorithm = MessageDigest.getInstance("MD5");
      algorithm.reset();
      algorithm.update(param.getBytes());
      byte[] messageDigest = algorithm.digest();
      return toHexString(messageDigest);
    } catch (Exception e) {
      throw new RRException("生成Token失败", e);
    }
  }
}
