package com.devplatform.admin.modules.sys.service;

import com.devplatform.admin.modules.sys.bean.SysFaulalarm;
import com.devplatform.admin.modules.sys.model.SysFaulalarmModel;
import com.devplatform.common.service.MyBaseService;

import java.util.List;
import java.util.Map;

/**
 * 设备故障报警表的service接口
 * <br>
 * <b>功能：</b>SysFaulalarmService<br>
 * @author 代码生成器产生
 */
public interface SysFaulalarmService extends MyBaseService<SysFaulalarm> {

    /**
     * 查询设备故障报警表分页数据
     * @param model
     * @return
     */
    List<SysFaulalarm> queryPageList(SysFaulalarmModel model);

    /**
     * 按资源点类型分组统计数量
     * @param params
     * @return
     */
    List<Map<String,Object>> getListGroupByResourceType(Map<String, Object> params);

    /**
     * 按资源点id分组统计数量
     * @param params
     * @return
     */
    List<Map<String,Object>> getListGroupByResourceId(Map<String, Object> params);

    /**
     * 按资源点类型得到当天的报警数
     * @param resourceType
     * @return
     */
    List<Map<String,Object>>  getCountByResourceType(String resourceType,String startTime,String endTime);
}
